#property  copyright "Copyright  2005, Yura Prokofiev"
#property  link      "Yura.prokofiev@gmail.com"
// Modofied by ACS to create sound alert and Text Signals and option to calculate the proper way.
// 30-Nov-07.
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Black
#property  indicator_color2  Lime
#property  indicator_color3  Red

extern int period=21;
extern int option=0;  // option 1 will make it NOT a repainter. Other options leave it as a repainter!
extern int TextPosition=675;
extern bool SoundAlert  = true;
extern string SoundFile="alert";

double         ExtBuffer0[];
double         ExtBuffer1[];
double         ExtBuffer2[];
int LastBar=-1;
string TextDir="SolarWind-ACS";
int init()
  {
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,3);
   IndicatorDigits(Digits+1);

   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);

//--- slight mod to show currency pair and Period
//--- by nittany1 on forex-tsd, hope this helps

   IndicatorShortName("");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);

   return(0);
  }
int deinit() { ObjectDelete(TextDir); return(0); }

int start()
  {
   //int     period=10;
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current,old;
   double Value=0,Value1=0,Value2=0,Fish=0,Fish1=0,Fish2=0;
   double price;
   double MinL=0;
   double MaxH=0;  
   

   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

if (option!=1) {
   for(int i=0; i<limit; i++)
    {  MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
       MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
      price = (High[i]+Low[i])/2;
      Value = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value1;     
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      ExtBuffer0[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
      Value1=Value;
      Fish1=ExtBuffer0[i];
      
    } }

if (option==1) {
   for(i=limit-2; i>=0; i--)
    {  MaxH = High[Highest(NULL,0,MODE_HIGH,period,i)];
       MinL = Low[Lowest(NULL,0,MODE_LOW,period,i)];
      price = (High[i]+Low[i])/2;
      Value = 0.33*2*((price-MinL)/(MaxH-MinL)-0.5) + 0.67*Value1;     
      Value=MathMin(MathMax(Value,-0.999),0.999); 
      ExtBuffer0[i]=0.5*MathLog((1+Value)/(1-Value))+0.5*Fish1;
      Value1=Value;
      Fish1=ExtBuffer0[i];
      
    } }


   bool up=true;
   for(i=limit-2; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
           
      if (((current<0)&&(prev>0))||(current<0))   up= false;    
      if (((current>0)&&(prev<0))||(current>0))   up= true;
      
      if(!up)
        {
         ExtBuffer2[i]=current; Commenter(-1);
         ExtBuffer1[i]=0.0;
        }
        
       else
         {
          ExtBuffer1[i]=current; Commenter(1);
          ExtBuffer2[i]=0.0;
         }
     }
   if (!SoundAlert || LastBar >= Bars) return(0);
   if (ExtBuffer1[0] > 0 && ExtBuffer1[1] <= 0) { Alert(Symbol()," ",Period( ),"M"," Solar wind crossed up"); PlaySound(SoundFile); LastBar=Bars; }
   if (ExtBuffer2[0] < 0 && ExtBuffer2[1] >= 0) { Alert(Symbol()," ",Period( ),"M"," Solar wind crossed down"); PlaySound(SoundFile); LastBar=Bars; }
   return(0);
  }
//+------------------------------------------------------------------+ TextSignal
void Commenter(int Dir) {
   ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
   ObjectSet(TextDir,OBJPROP_XDISTANCE,TextPosition);
   ObjectSet(TextDir,OBJPROP_YDISTANCE,2);
   if (Dir == 1) ObjectSetText(TextDir,"BUY",12,"Arial Black",Blue);
   if (Dir == -1) ObjectSetText(TextDir,"SELL",12,"Arial Black",Red);
return; }
//===================================================================

                